#############################################################
# Data preparation for the shiny interface "Synthesis"
############################################################
rm(list=ls())

library(dplyr)
library(ggplot2)
library(gtools)
library(data.table)
library(ggpubr)
library(tidyr)
library(knitr)
library(cowplot)

## Chemins
## -------
#pathRData<- 'Q:/PECHALO/Scenarios_analyse_incertitude_2/RData/'   # path o? enregistrer les sorties (RData)
pathRData<- 'C:/Users/smahevas/C-ISISFish/2023_Atelier2_MIMI/RDataPrepShiny/'
#pathCombinaisonSimulation <- 'Q:/PECHALO/Scenarios_analyse_incertitude_2/csv_plan/' # plan d'exp
pathCombinaisonSimulation <-'C:/Users/smahevas/C-ISISFish/2023_Atelier2_MIMI/csv_plan/'
#simFolder<-'E:/isis-fish-4/isis-database/simulations/'   # path o? se trouvent les sorties d'isis
#simFolder<- 'C:/Users/smahevas/C-ISISFish/isis-fish-4/isis-database/simulations/'
simFolder<- 'G:/DossierSauvegarder/C-ISISFish/2023_Atelier2_MIMI/Simulations/'
## Pattern simu
## ------------

pattern <- "as_planComplet_4param_60mois_TailleMin_2023-01-31-21-10"
## Nom listRes
## -----------

name_listRes<-"plan_TailleMin_SR1a5et8"
## Import combinaisons simu
## ------------------------

load(paste0(pathRData,"listRes_MIMI_",name_listRes,".RData"))
planY <-listRes[[1]]
Yname <- "Biomasse"
planY <-listRes[[2]]
Yname="Captures"
planY <-listRes[[3]]
Yname="SSB"

###Calcul des ISBiomass
########Calcul et visualisation des indices de sensibilit?
mod = aov(value~Survie+Derive+Dispersion+RelationSR+Survie*Derive+Survie*Dispersion+Survie*RelationSR+Derive*Dispersion+Derive*RelationSR+Dispersion*RelationSR, data = planY)
ano = anova(mod)
SoS<-ano[1:(dim(ano)[1]-1),2]
names(SoS)<-dimnames(ano)[[1]][1:(dim(ano)[1]-1)]
Ts <-sum(ano[,2])
Rsquarre <- sum(SoS)/Ts
IndSensibilite <- SoS/sum(SoS)
windows()
par(mar = c(9, 4, 4, 2))
barplot(sort(IndSensibilite),las=2,main=Yname)


IndSensibiliteTotaux <- c(sum(IndSensibilite[grep("Survie",names(IndSensibilite))]),
sum(IndSensibilite[grep("Derive",names(IndSensibilite))]),
sum(IndSensibilite[grep("Dispersion",names(IndSensibilite))]),
sum(IndSensibilite[grep("RelationSR",names(IndSensibilite))]))

save(IndSensibiliteTotaux,file=paste0(pathRData,"IndSensibiliteTotaux",Yname,name_listRes,".RData")) 

windows()
p <- ggplot(data = planY) + geom_point( aes(x=Derive, y=value) )
p

windows()
p <- ggplot(data = planY) + geom_point( aes(x=RelationSR, y=value)  )
p
windows()
p <- ggplot(data = planY) + geom_point( aes(x=Survie, y=value)  )
p
windows()
p <- ggplot(data = planY) + geom_point( aes(x=Dispersion, y=value)  )
p
