#############################################################
# Data preparation for the shiny interface "Synthesis"
############################################################
rm(list=ls())

library(dplyr)
library(ggplot2)
library(gtools)
library(data.table)
library(ggpubr)
library(tidyr)
library(knitr)
library(cowplot)

## Chemins
## -------
#pathRData<- 'Q:/PECHALO/Scenarios_analyse_incertitude_2/RData/'   # path o? enregistrer les sorties (RData)
pathRData<- 'C:/Users/smahevas/C-ISISFish/2023_Atelier2_MIMI/RDataPrepShiny/'
#pathCombinaisonSimulation <- 'Q:/PECHALO/Scenarios_analyse_incertitude_2/csv_plan/' # plan d'exp
pathCombinaisonSimulation <-'C:/Users/smahevas/C-ISISFish/2023_Atelier2_MIMI/csv_plan/'
#simFolder<-'E:/isis-fish-4/isis-database/simulations/'   # path o? se trouvent les sorties d'isis
#simFolder<- 'C:/Users/smahevas/C-ISISFish/isis-fish-4/isis-database/simulations/'
simFolder<- 'G:/DossierSauvegarder/C-ISISFish/2023_Atelier2_MIMI/Simulations/'
## Pattern simu
## ------------
#pattern<-"sim_planSimu_PECHALO_2019-11-18-18-03"
#pattern<-"sim_PLAN_calib_simu_3768_2019-11-26-15-17"
#pattern<-"sim_plan_simu3176_2019-11-29-17-26"
#pattern<-"as_planComplet_4param_60mois_2023-01-10-12-26"
#pattern <-"as_planComplet_4param_60mois_MPA_2023-01-22-15-29"
#pattern <-"as_planComplet_4param_60mois_TAC200_2023-01-28-17-08"
#pattern <-"as_planComplet_4param_60mois_ssRegle_2023-01-29-00-43"

#pattern <-"as_planComplet_4param_60mois_TAC200_SR6a10_2023-01-29-10-40"
#pattern <- "as_planComplet_4param_60mois_TAC500_TailleMin_2023-01-30-20-38"
pattern <- "as_planComplet_4param_60mois_MPA_TailleMin_2023-01-30-20-40"
## Nom listRes
## -----------
#name_listRes<-"plan_simu_3176"
#name_listRes<-"plan_TAC900"
#name_listRes<-"plan_MPA"
#name_listRes<-"plan_TAC200"
#name_listRes<-"plan_ssRegle"

#name_listRes<-"plan_TAC200_SR6a10"
#name_listRes<-"plan_TAC500_TailleMin_SR1a5et8"
name_listRes<-"plan_MPA_TailleMin_SR1a5et8"
## Import combinaisons simu
## ------------------------
combinaisons<-"CombinaisonSimulation"
CombinaisonSimulation <- fread(paste0(pathCombinaisonSimulation,"plan648",".txt"), sep=',', h=T)
CombinaisonSimulation <- CombinaisonSimulation[,-c(1,6)] 

##################
# liste des simus 
simPath1 = list.files(simFolder, pattern=pattern)
simPath1 <- mixedsort(sort(simPath1)) # uniquement si le dossier du plan (dans isis-fish-4) n'a pas ?t? supprim?
#simPath1 <- simPath1[-1] # uniquement si le dossier du plan (dans isis-fish-4) n'a pas ?t? supprim?

# nb simus
nb_simus=length(simPath1)

  # lire les simus et les stocker dans des listes

# Read simulation Exports and store results of biomass, catch, discard, revenues per year, pop, simulation
biosc <- data.frame()
ssbiosc <- data.frame()
catsc <- data.frame()
  # + ajout co?ts carburant & revenus autres poissons

# Exports : d?j? agreg?s par ann?e

for(s in (1:nb_simus)){
    print(s)
    ssbiomass = read.csv(paste0(simFolder,simPath1[s],'/resultExports/BiomasseFeconde.csv'),header=F,sep=";")
    colnames(ssbiomass) = c("pop","group","zone","step","value")
    biomass = read.csv(paste0(simFolder,simPath1[s],'/resultExports/BiomasseBeginMonth.csv'),header=T,sep=";")
   # catch = read.csv(paste0(simFolder,simPath1[s],'/resultExports/CapturesPoidsStrategies.csv'),header=T,sep=";")
    catch = read.csv(paste0(simFolder,simPath1[s],'/resultExports/CapturesPoids.csv'),header=T,sep=";")
    
    
    biomass$month = floor(biomass$step%%12)
    biomass$year = floor(biomass$step/12)
    biomass2 <- biomass[biomass$month==0,]
    bio <- aggregate(value ~ year, data=biomass2, FUN=sum)
    names(bio) <- c("year","val")
    bio$simname <- s
    biosc <- rbind(biosc,bio)
    
    ssbiomass$month = floor(ssbiomass$step%%12)
    ssbiomass$year = floor(ssbiomass$step/12)
    ssbiomass2 <- ssbiomass[ssbiomass$month==0,]
    ssbio <- aggregate(value ~ year, data=ssbiomass2, FUN=sum)
    names(ssbio) <- c("year","val")
    ssbio$simname <- s
    ssbiosc <- rbind(ssbiosc,ssbio)
    
    catch$year = floor(catch$step/12)
    cat <- aggregate(value ~ year, data=catch, FUN=sum)
    #names(catch) <- c("str","year","val")
    names(catch) <- c("year","val")
    cat$simname <- s
    catsc <- rbind(catsc,cat)
}

# greffer le tableau de combinaison aux simus 
#--------------------------------------------
#colnames(CombinaisonSimulation) =  c('Eff_initiaux','Recrutement','Connectivite','Scenarios')
colnames(CombinaisonSimulation) =  c('Derive','Survie','Dispersion','RelationSR')
CombinaisonSimulation$simname <- seq(1, nrow(CombinaisonSimulation), 1)

listRes = list("Biomass"=merge(biosc,CombinaisonSimulation,by=c('simname')),"Catch"=merge(catsc,CombinaisonSimulation,by=c('simname'))) 
save(listRes,file=paste0(pathRData,"listRes_MIMI_",name_listRes,".RData")) 



