library(ggplot2)
library(dplyr)

versionResults = "listRes13122019"
synth = get(load(paste0("./data/",versionResults,"/Synthesis_listRes_PECHALO2_both.RData")))
load(paste0("./data/listRes_MIMI_plan5400.RData"))


res = listRes[[1]]
#res<- res[res$Scenarios == "0_StatusQuo" & res $Eff_initiaux== 0,]
res<- res %>% filter(Scenarios =="TAC")
sc = res$Scenarios
resname = "Biomasse"


uncerts <- names(res)[which( ! names(res) %in% c("simname","year","value","Scenarios"))]
uncexp <- uncerts
# uncexp <- ''

respop= res
respop$basecase <- "pasBC"
respop$basecase[which(rowSums(respop[,uncerts]) == 0)] <- "BC"
respop$size <- 1
respop$size[respop$basecase == "BC"] <- 2
respop$simChar = paste0(respop$Scenarios, respop$simname,"R",respop$RelationSR,"D",respop$Derive,"Di",respop$Dispersion,"S",respop$Survie)
uncexpcol <- "RelationSR"


ggplot(data=respop, aes(x=as.factor(year),y=value,colour = '')) + 
  xlab("years")+
  geom_point()+
  #geom_dotplot(binaxis='y', stackdir='center')+
  stat_summary(fun.data="mean_cl_boot",colour="red",size=2)
  
  stat_summary(fun.data="mean_sdl", fun.args = list(mult=1), 
               geom="crossbar", width=0.5,mapping=aes(group=year))

  
  ggplot(data=respop, aes(x=as.factor(year),y=value))+
    geom_boxplot()+
    scale_size_manual(values=c(2,1))+
    theme(panel.grid.major = element_blank(),text = element_text(size=15))+
    stat_summary(fun=mean, geom="point", shape=23, size=4)+
    geom_dotplot(binaxis='y', stackdir='center',aes(fill= as.factor(get(uncexpcol))))+
    xlab("years")+ggtitle( paste(paste(resname,'test',sep="-")) ) 
    
  
ggbase<-  ggplot(data=respop, aes(x=year,y=value))+
        scale_size_manual(values=c(2,1))+
    theme(panel.grid.major = element_blank(),text = element_text(size=15))+
    #stat_summary(fun=mean, geom="point", shape=23, size=4)+
  xlab("years")+ggtitle( paste(paste(resname,'test',sep="-")))    

ggbase2 <- ggplot(data=respop, aes(x= as.factor(year),y=value))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years")

#########################################################


listtest <- list()
  
listtest[[1]] <- ggbase + geom_point(aes(colour= as.factor(get(uncexpcol))))
listtest[[2]] <- ggbase + geom_jitter(shape=16, position=position_jitter(0.2),aes(colour= as.factor(get(uncexpcol))))
listtest[[3]] <- 
  
  ggbase + geom_dotplot(binaxis='y', stackdir='center',aes(fill= as.factor(get(uncexpcol))))

do.call("grid.arrange",c(listtest))

  
ggbase + geom_point(aes(colour= as.factor(none)))
  
}else 
  
  
  ggplot(data=respop, aes(x=as.factor(year),y=value))+
    scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  stat_summary(fun=mean, geom="point", shape=23, size=4)+
  xlab("years")+ggtitle( paste(paste(resname,'test',sep="-")) )  +
 geom_dotplot(binaxis='y', stackdir='center')
  

ggplot(data=respop, aes(x=as.factor(year),y=value,group=simChar))+
  xlab("years")+ 
  geom_line()
  
ggplot(data=respop, aes(x= as.factor(year),y=value,group=simChar))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years") +
  #ggbase + # ne pas utiliser as factor ?? 
  geom_point(aes(color= as.factor(get(uncexpcol))))+
  geom_line(aes(color= as.factor(get(uncexpcol))))+
  scale_color_brewer(palette = "Paired")



ggbase2 + 
  geom_dotplot(binaxis='y', stackdir='center',aes(fill=as.factor(get(uncexpcol))),dotsize=0.6)+
  stat_summary(geom="pointrange", color="red")



ggplot(data=respop, aes(x= as.factor(year),y=value))+ 
  geom_violin()+
  geom_dotplot(binaxis='y', stackdir='center',dotsize=0.6,aes(fill=as.factor(Recrutement)))
#  geom_line(aes(group=simChar))

  

gg <- ggbase2 + 
  geom_violin()
  #geom_line(aes(group=simChar))+

gg + geom_dotplot(binaxis='y', stackdir='center',dotsize=0.6,aes(fill=as.factor(get(uncexpcol))))
x11()
gg + geom_dotplot(binaxis='y', stackdir='center',dotsize=0.6,fill="white")



stat_sum_df <- function(fun, geom="crossbar", ...) {
  stat_summary(fun.data = fun, colour = "red", geom = geom, width = 0.2, ...)
}

median.quartile <- function(x){
  out <- quantile(x, probs = c(0.25,0.5,0.75))
  names(out) <- c("ymin","y","ymax")
  return(out)
}

mean.quartile <- function(x){
  out <- c(quantile(x, probs = c(0.25,0.75)),mean(x))
  names(out) <- c("ymin","ymax","y")
  return(out)
}

ggbase2 +
  geom_dotplot(binaxis='y', stackdir='center')+
  #stat_summary(fun.data = mean.quartile,geom="crossbar", width=1,size=0.5,color="blue")+
  stat_summary(fun.data = median.quartile,geom="crossbar", width=1,size=0.5,color="blue")+
  #stat_sum_df("mean_sdl", mapping = aes(group = year))
  #stat_summary(fun.data = mean_sdl, geom = "errorbar")+
  # geom_line() +  stat_summary(fun = "mean", geom = "point", size=6)
  #stat_summary(fun.data = median.quartile,geom="pointrange", color="red",size=2)+
  stat_summary(fun = mean,geom="point", color="red",size=2)
  geom_boxplot()

  ggplot(data=respop, aes(x= year,y=value))+
    stat_summary(fun.data = mean.quartile,geom="ribbon",alpha=0.2)+
    stat_summary(fun=mean,geom="line",size=2)+
    geom_point(colour="black") + 
    scale_size_manual(values=c(2,1))+
    theme(panel.grid.major = element_blank(),text = element_text(size=15),legend.position = "none")+
    xlab("years") +
    ggtitle( paste(paste(resname,"enveloppe",sep="-")) )
  
  # ribon qui marche
  
  ggplot(data=respop, aes(x= year,y=value,color=as.factor(Recrutement))) + 
     stat_summary(fun.data = mean.quartile,geom="ribbon",alpha=0.2)+
    geom_point()
  
  ggplot(data=respop, aes(x= year,y=value,group=as.factor(RelationSR),fill=as.factor(Recrutement),colour=as.factor(Recrutement))) + 
    stat_summary(fun.data = mean.quartile,geom="ribbon",alpha=0.2)+
    stat_summary(fun=mean,geom="line",size=2)+
    geom_point(colour="black") 

  
  
  summData <- respop %>% group_by(year,Connectivite) %>% summarise(moy = mean(value),ymin =mean(value)-sd(value),ymax = mean(value)+sd(value))
  
  ggplot(respop,aes(x= year,y=value,color=Connectivite))+geom_hline(yintercept = 2e7)+
   geom_point()+
   # geom_line(data = summData, aes(x= year,y=moy,colour=Connectivite))+
   # geom_ribbon(data = summData,aes(x=year,y=moy,ymin=ymin,ymax=ymax,fill=Connectivite), alpha=0.5)+
    facet_wrap(.~Recrutement)
  
  # ca marche sans les points
  ggplot(summData,aes(x=year,y=moy,ymin=ymin,ymax=ymax,fill=as.factor(Connectivite)))+
    geom_line()+
    geom_ribbon(alpha=0.5)
      geom_point(data=respop, aes(x=year,y=value))
  
  
      ggplot(data=respop, aes(x=year,y=value))+geom_point()+
        geom_line(data=summData,aes(x=year,y=moy,colour=as.factor(Connectivite)))+
        geom_ribbon(data=summData,aes(x=year,y=moy,ymin=ymin,ymax=ymax,fill=as.factor(Connectivite)), alpha=0.2)
      
  
  
  stat_summary(fun.y = mean,
             fun.ymin = function(x) mean(x) - sd(x), 
             fun.ymax = function(x) mean(x) + sd(x), 
             geom = "line") +
  stat_summary(fun.y = mean,
               geom = "line")
    
  
  
  respop <- respop %>% mutate(obs=1,crit = if_else(value < listObj[[resname]], 1, 0),
                              objectif = c("au-dessus","en-dessous")[crit+1])

  Yrisk <- respop %>% group_by(Scenarios,objectif)%>% summarise(sumobs = sum(obs))%>% ungroup()%>%
                    group_by(Scenarios) %>% mutate(risque = sumobs/sum(sumobs)*100)
  
  prisk <- ggplot(Yrisk,aes(x=Scenarios,y=risque,fill=objectif)) + geom_bar(stat="identity")+
  ggtitle(paste0("Risque d'être sous l'objectif"))
  
  respop <- respop %>% mutate(obs=1,crit = if_else(value < 2e7, 1, 0),
                              objectif = c("au-dessus","en-dessous")[crit+1])
  Yrisk <- respop %>% group_by(Scenarios,objectif)%>% summarise(sumobs = sum(obs))%>% ungroup()%>%
    group_by(Scenarios) %>% mutate(risque = sumobs/sum(sumobs)*100)
  
  
  ggplot(Yrisk,aes(x=Scenarios,y=risque,fill=objectif)) + geom_bar(stat="identity")+
    ggtitle(paste0("Risque d'être sous l'objectif"))+
    geom_hline(yintercept = c(50,5),linetype = c("dotted","dashed"))+
    scale_fill_manual(values=c("aquamarine", "coral1"))
    #scale_fill_manual(values=c("#999999", "#E69F00"))
  
  
  ggplot(data=respop%>% filter(year %in% c(2020:2024)), aes(x=value,fill=Scenarios, colour=Scenarios))+
    geom_density(alpha=.2,size=1) + coord_flip()+facet_wrap(.~year,nrow=1)
    geom_vline(xintercept = c(2e7*c(1,0.95,1.05)),linetype = c("dashed","dotted","dotted"))
  
  
  
  
  
ggplot(data=respop, aes(x= year,y=value,colour=Scenarios))+
    scale_size_manual(values=c(2,1))+
    theme(panel.grid.major = element_blank(),text = element_text(size=15))+
    xlab("years") +  geom_hline(yintercept = c(2e7*c(1,0.95,1.05)),linetype = c("dashed","dotted","dotted"))+
    geom_boxplot()



ggplot(data=respop, aes(x= year,y=value,colour=Scenarios))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years") +  geom_hline(yintercept = 1.5e7)+
# geom_line(aes(group=simChar)) + geom_point() +  
  #stat_summary(fun.data = mean.quartile,geom="pointrange", position=position_dodge(0.9),color="yellow",size=2)
  stat_summary(fun.data = mean.quartile,geom="pointrange",size=2,fill="red")



ggplot()+aes(x=c(1),y=c(1:5),label="test")+geom_text()+ theme_bw()+ theme_void()


mean.quartile <- function(x){
  
  out <- c(mean(x)-sd(x),mean(x),mean(x)+sd(x))#quantile(x, probs = c(0.55,0.75)),mean(x))
  names(out) <- c("ymin","y","ymax")
  return(out)
}
  
ggplot(data=respop, aes(x= year,y=value)) +
  stat_summary(fun=mean,geom="line",size=2,colour="blue")+ 
  stat_summary(fun.data = mean.quartile,geom="ribbon",alpha=0.2)+
  geom_point(colour="black") + 
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15),legend.position = "none")+
  xlab("years")

respop = listRes[[1]]
uncerts = c("Derive","Survie","Dispersion","RelationSR")
respop$basecase <- "pasBC"
respop$basecase[which(rowSums(respop[,paste0(uncerts,"_ref")]) == 0)] <- "BC"
respop$size <- 1
respop$size[respop$basecase == "BC"] <- 2
respop$simChar = paste0(respop$simname,"D",respop$Derive,"S",respop$Survie,"Di",respop$Dispersion,"SR",respop$RelationSR)

ggplot(data=respop, aes(x= year,y=value,group=simChar,colour=as.factor(RelationSR)))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years") +  geom_point() + geom_line()

ggplot(data=respop, aes(x= year,y=value,group=simChar,colour=as.factor(Derive_ref)))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years") +  geom_point() + geom_line()+facet_wrap(.~Derive)
 



###scenarios

ggbaseY <- ggplot(data=respop, aes(x= year,y=value,colour=Scenarios))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years") +  geom_hline(yintercept = listObj[[resname]])+
  scale_colour_manual(values=c("#999999", "#E69F00", "#56B4E9"))

ggbaseY2 <- ggplot(data=respop, aes(x= as.factor(year),y=value,colour=Scenarios))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15))+
  xlab("years") +  geom_hline(yintercept = listObj[[resname]])+
  scale_colour_manual(values=c("#999999", "#E69F00", "#56B4E9"))

ggbaseSc <- ggplot(data=respop, aes(x= Scenarios,y=value,colour=Scenarios))+
  scale_size_manual(values=c(2,1))+
  theme(panel.grid.major = element_blank(),text = element_text(size=15),legend.position = "none")+
  xlab("Scenarios") +  geom_hline(yintercept = listObj[[resname]])+
  scale_colour_manual(values=c("#999999", "#E69F00", "#56B4E9"))


ggbaseY2 + geom_dotplot(binaxis='y', stackdir='center',aes(fill= Scenarios,colour = Scenarios),dotsize=0.01,position=position_dodge(0.8))
ggbaseY2 + geom_violin()
ggbaseY2 + stat_summary(fun.data = mean.quartile,geom="pointrange",size=2)

ggplot(data=respop, aes(x= as.factor(year),y=value,colour=Scenarios))+
  stat_summary(fun.data = mean.quartile,geom="pointrange",size=2,position=position_dodge(0.5))

ggplot(data=respop%>%filter(year==2027), aes(x= year,y=value,colour=Scenarios))+  
  geom_line(aes(group=simChar))+
  geom_point(position=position_dodge(0.5))+
  ggtitle(paste0(resname,"-points"))

ggbaseY + 
  ggtitle(paste0(resname,"-lignes"))+
  geom_line(aes(group=simChar),linetype=2) + geom_point(position=position_dodge(0.5)) 

ggbaseSc + geom_point(position=position_dodge(0.5))
ggbaseY2 + geom_violin(scale="width")
