### rename RData 
library(dplyr)



# Rename objects 
renomme = function(listoto,sc="sc"){
  names(listoto) <- c("Biomasse","Captures","SSB")
  listoto[["Biomasse"]] <- listoto[["Biomasse"]] %>% rename(value= val)
  listoto[["SSB"]] <- listoto[["SSB"]] %>% rename(value= val)
  for( i in 1:length(listoto)) {
    listoto[[i]]$year <- listoto[[i]]$year + 2023
    listoto[[i]]$Scenarios <- sc
    listoto[[i]]$value <- listoto[[i]]$value/1000
    listoto[[i]]$Derive_ref <- listoto[[i]]$Derive
    listoto[[i]]$Derive <- -0.05 + listoto[[i]]$Derive * 0.05
    listoto[[i]]$Derive[listoto[[i]]$Derive == 0] <- "0 (ref)"
    listoto[[i]]$Survie_ref <- listoto[[i]]$Survie
    listoto[[i]]$Survie <- 0.1 + listoto[[i]]$Survie * 0.1
    listoto[[i]]$Survie[listoto[[i]]$Survie == 0.5] <- "0.5 (ref)"
    listoto[[i]]$Dispersion_ref <- listoto[[i]]$Dispersion 
    listoto[[i]]$Dispersion <- c("non (ref)","oui")[listoto[[i]]$Dispersion+1]
    listoto[[i]]$RelationSR_ref <- listoto[[i]]$RelationSR
    listoto[[i]]$RelationSR <- c("Beverton-Holt (ref)","Ricker","Hockey stick","Fecondité","Uniforme","Uniforme")[listoto[[i]]$RelationSR+1] 
    listoto[[i]] <- listoto[[i]]%>% filter(RelationSR_ref != 4)
  }
  
  return(listoto)
}

# load 31/01 version

load(paste0("./data/listRes_MIMI_plan_TAC500_TailleMin_SR1a5et8.RData"))
listResTAC = renomme(listRes,"TAC")

load(paste0("./data/listRes_MIMI_plan_TailleMin_SR1a5et8.RData"))
listResssRegle = renomme(listRes,"Référence")

load(paste0("./data/listRes_MIMI_plan_MPA_TailleMin_SR1a5et8.RData"))
listResMPA = renomme(listRes,"MPA")

listRes <- list()
for(noms in names(listResMPA)){
  listRes[[noms]] <- rbind(listResTAC[[noms]],listResMPA[[noms]])
  listRes[[noms]] <- rbind(listRes[[noms]],listResssRegle[[noms]])
}

save(listRes,file = "./data/listRes_MIMI_3101.RData")








# older versions
load(paste0("./data/listRes_MIMI_plan_TAC200.RData"))
listResTAC = renomme(listRes,"TAC")
save(listRes,file = "./data/listRes_MIMI_plan_TAC900_renamed.RData")


load(paste0("./data/listRes_MIMI_plan_ssRegle.RData"))
listResssRegle = renomme(listRes,"aucun")
save(listRes,file = "./data/listRes_MIMI_plan_TAC900_renamed.RData")


load(paste0("./data/listRes_MIMI_plan_MPA.RData"))
listResMPA = renomme(listRes,"MPA")
save(listRes,file = "./data/listRes_MIMI_plan_MPA_renamed.RData")

listRes <- list()
for(noms in names(listResMPA)){
  listRes[[noms]] <- rbind(listResTAC[[noms]],listResMPA[[noms]])
  listRes[[noms]] <- rbind(listRes[[noms]],listResssRegle[[noms]])
}

save(listRes,file = "./data/listRes_MIMI_plan5400.RData")
