if('lignes'%in% input$graphType){
  # Plot
  gg <- ggbase +
    ggtitle( paste(paste(resname,input$graphType,sep="-")) ) 
  if(uncexpcol != ''){gg <- gg +
    geom_point(aes(color= as.factor(get(uncexpcol))))+
    geom_line(aes(color= as.factor(get(uncexpcol)))) #aes(linetype=basecase, size=basecase))+
  }else{gg <- gg + geom_point() + geom_line()}
  if(uncexp != ''){gg <- gg + facet_wrap(.~respop[,uncexp])
  }else {gg<- gg + 
    geom_line(data=respop%>% filter(basecase == "BC"),colour="turquoise")}
  
  plotlist[[paste(resname,1,sep="-")]] <- gg}

if('enveloppe' %in% input$graphType){ # graph2
  
  if(uncexpcol != ''){gg <- ggplot(data=respop, aes(x= year,y=value,
                                                    color=as.factor(get(uncexpcol)),group=as.factor(get(uncexpcol)),fill=as.factor(get(uncexpcol))))+
    stat_summary(fun=mean,geom="line",size=2)
  }else{gg <- ggplot(data=respop, aes(x= year,y=value)) +
    stat_summary(fun=mean,geom="line",size=2,colour="blue")}
  
  if(input$obj == TRUE){
    gg  <- gg +  geom_hline(yintercept = listObj[[resname]])
  }
  
  gg <- gg + 
    stat_summary(fun.data = mean.quartile,geom="ribbon",alpha=0.2)+
    geom_point(colour="black") + 
    scale_size_manual(values=c(2,1))+
    theme(panel.grid.major = element_blank(),text = element_text(size=15),legend.position = "none")+
    xlab("years") +
    ggtitle( paste(paste(resname,"enveloppe",sep="-")) )
  
  if(uncexp != ''){gg <- gg + facet_wrap(.~respop[,uncexp])}
  
  plotlist[[paste(resname,2,sep="-")]] <- gg }

#https://r-graph-gallery.com/104-plot-lines-with-error-envelopes-ggplot2.html

if ('points' %in% input$graphType){ # graph 1 TS brutes
  gg <- ggbase + ggtitle( paste(paste(resname,"points",sep="-")) )
  if(uncexpcol != ''){gg <- gg + geom_point(aes(colour= as.factor(get(uncexpcol))))
  }else {gg <- gg + geom_point()}
  if(uncexp != ''){gg <- gg + facet_wrap(.~respop[,uncexp])}
  
  plotlist[[paste(resname,3,sep="-")]] <- gg}

if('dotplot' %in% input$graphType){
  # group does not work with dotplot
  gg <- ggbase2 +
    ggtitle( paste(paste(resname,"points alignés",sep="-")) )
  
  if(uncexpcol != ''){gg <- gg + geom_dotplot(binaxis='y', stackdir='center',aes(fill= as.factor(get(uncexpcol))),dotsize=set_dotsize,position=position_dodge(0.8))
  }else{gg <- gg + geom_dotplot(binaxis='y', stackdir='center',dotsize=set_dotsize)}
  if(uncexp != ''){gg <- gg + facet_wrap(.~respop[,uncexp])}
  
  plotlist[[paste(resname,4,sep="-")]] <- gg}

if('violon'%in% input$graphType){ # violon
  
  gg <- ggbase2 + 
    geom_violin()+
    #geom_line(aes(group=simChar))+
    ggtitle( paste(paste(resname,"violon",sep="-")) ) 
  
  if(input$sansPts == FALSE){
    if(uncexpcol != ''){gg <- gg + geom_dotplot(binaxis='y', stackdir='center',
                                                dotsize=set_dotsize,aes(fill=as.factor(get(uncexpcol))),position=position_dodge(0.8))
    }else{gg <- gg + geom_dotplot(binaxis='y', stackdir='center',dotsize=set_dotsize,fill="white")}}
  if(uncexp != ''){ gg <- gg + facet_wrap(.~respop[,uncexp])}
  
  plotlist[[paste(resname,5,sep="-")]] <- gg}

if('densite' %in% input$graphType){
  if(uncexpcol != ''){ gg <- ggplot(data=respop, aes(x=value,fill=as.factor(get(uncexpcol)), 
                                                     colour=as.factor(get(uncexpcol))))+
    geom_density(alpha=.2,size=1)+
    scale_color_brewer(palette = "Paired")+
    scale_fill_brewer(palette = "Paired")+
    coord_flip()+ facet_wrap(.~year,ncol=5)
  
  }else {
    gg <- ggplot(data=respop, aes(x=value))+ 
      geom_density(alpha=.2,size=1) + coord_flip()+ facet_wrap(.~year,ncol=5)
  }
  gg <- gg + scale_size_manual(values=c(2,1))+
    theme(panel.grid.major = element_blank(),text = element_text(size=15),legend.position = "none")+
    xlab("years") +ggtitle(paste(resname,"densité",sep="-"))
  
  plotlist[[paste(resname,6,sep="-")]] <- gg}

if('fourchettes' %in% input$graphType){ # POINT RANGE
  
  gg <- ggbase2 + 
    stat_summary(fun.data = mean.quartile,geom="pointrange", color="blue",size=2)+
    geom_line() +  stat_summary(fun = "median", geom = "point", size=4,colour="purple")+
    ggtitle( paste(paste(resname,"Fourchettes",sep="-")) )
  
  if(input$sansPts == FALSE){
    if(uncexpcol != ''){gg <- gg +
      geom_dotplot(binaxis='y', stackdir='center',aes(fill=as.factor(get(uncexpcol))),dotsize=set_dotsize,position=position_dodge(0.8))
    }else{gg <- gg + geom_dotplot(binaxis='y', stackdir='center',fill="white",dotsize=set_dotsize)}}
  
  if(uncexp != ''){gg <- gg + facet_wrap(.~respop[,uncexp])}
  
  
  plotlist[[paste(resname,7,sep="-")]] <- gg}

if('boite'%in% input$graphType){ # CROSSBAR
  if(input$sansPts == FALSE){
    if(uncexpcol != ''){gg <- ggbase2 + geom_dotplot(binaxis='y', stackdir='center',dotsize=set_dotsize,aes(fill=as.factor(get(uncexpcol))),position=position_dodge(0.8))
    }else{gg <- ggbase2 + geom_dotplot(binaxis='y', stackdir='center',dotsize=set_dotsize,fill="white")}}
  if(uncexp != ''){ gg <- gg + facet_wrap(.~respop[,uncexp])}
  
  gg <- gg +
    #geom_dotplot(binaxis='y', stackdir='center',aes(fill=Scenarios))+
    stat_summary(fun = mean,geom="point", color="blue",size=2)+
    stat_summary(fun.data = median.quartile,geom="crossbar", width=0.5,size=1,color="purple")+
    ggtitle( paste(paste(resname,'boite',sep="-")) ) 
  
  if(uncexp != ''){ gg <- gg + facet_wrap(.~respop[,uncexp])}
  plotlist[[paste(resname,8,sep="-")]] <- gg}

if('boite-moustache'%in% input$graphType){
  
  ff <- function(x) {
    r <- quantile(x, probs = c(0, 0.05, 0.5, 0.95, 1))
    names(r) <- c("ymin", "lower", "middle", "upper", "ymax")
    r
  }
  
  gg <- ggbase2 + #geom_boxplot(colour="purple")+
    stat_summary(fun=mean, geom="point",color="blue", size=3)+
    stat_summary(fun.data = ff, geom="boxplot", position=position_dodge(1),colour="purple")+
    ggtitle( paste(paste(resname,'boiteMoustache',sep="-")) ) 
  
  if (input$sansPts==FALSE){
    if(uncexpcol != ''){gg <- gg + geom_dotplot(binaxis='y', stackdir='center',dotsize=set_dotsize,aes(fill=as.factor(get(uncexpcol))),position=position_dodge(0.8))
    }else{gg <- gg + geom_dotplot(binaxis='y', stackdir='center',dotsize=set_dotsize,fill="white")}}
  
  if(uncexp != ''){ gg <- gg + facet_wrap(.~respop[,uncexp])}
  plotlist[[paste(resname,9,sep="-")]] <- gg}
